#include "Board.h"
#include "FKUT/Misc.h"

BoardInfo::BoardInfo(void)
{
}

BoardInfo::~BoardInfo(void)
{
}

// =Iy[^̃I[o[[hŔՖʏ̃Rs[s
BoardInfo BoardInfo::operator=(const BoardInfo &argOP)
{
	// z̒lRs
	for(int i = 0; i < BOARD_WIDTH; ++i) {
		for(int j = 0; j < BOARD_WIDTH; ++j) {
			cellInfo[i][j] = argOP.cellInfo[i][j];
		}
	}

	return (*this);
}

// Ֆʂ̏
void BoardInfo::initBoard(void)
{
	// z̏l-1(uĂȂ)ŏ
	for(int i = 0; i < BOARD_WIDTH; ++i) {
		for(int j = 0; j < BOARD_WIDTH; ++j) {
			cellInfo[i][j].index = -1;
			cellInfo[i][j].color = ST_DEFAULT;
		}
	}
}

// œnF̐΂u󋵂ǂ𒲂ׂ(getPuttableList()ɏۓ)
bool BoardInfo::isPuttable(StoneColor nowTurn) const
{
	return getPuttableList(nowTurn, NULL);
}

// œnF̐΂uꏊ̃Xg𓾂
bool BoardInfo::getPuttableList(StoneColor nowTurn, list<CellPosition> *argList) const
{
	list<CellPosition>	revList;
	if(argList != NULL) argList->clear();
	
	for(int i = 0; i < BOARD_WIDTH; ++i) {
		for(int j = 0; j < BOARD_WIDTH; ++j) {
			CellPosition	pos(i, j);
			if(cellInfo[pos.x][pos.y].index >= 0) {
				continue;
			}
			if(checkAround(pos, nowTurn, false, &revList) == true) {
				if(argList != NULL) {
					argList->push_back(pos);
				} else {
					return true;
				}
			}
		}
	}
	
	if(argList != NULL) {
		if(argList->size() != 0) return true;
	}

	return false;
}

StoneColor BoardInfo::judge(int *argP_blackNum, int *argP_whiteNum) const
{
	// グ
	int blackNum = 0, whiteNum = 0;
	for(int i = 0; i < BOARD_WIDTH; ++i) {
		for(int j = 0; j < BOARD_WIDTH; ++j) {
			CellPosition	pos(i, j);
			if(cellInfo[pos.x][pos.y].color == ST_BLACK) {
				++blackNum;
			} else if(cellInfo[pos.x][pos.y].color == ST_WHITE) {
				++whiteNum;
			}
		}
	}

	// \pɃ|C^ʂČԂ
	if(argP_blackNum != NULL) {
		*argP_blackNum = blackNum;
	}
	if(argP_whiteNum != NULL) {
		*argP_whiteNum = whiteNum;
	}

	// sԂ
	if(blackNum > whiteNum) {
		return ST_BLACK;
	} else if(whiteNum > blackNum) {
		return ST_WHITE;
	}

	return ST_DEFAULT;
}

// ΂uꏊ𒲂ׂ֐
bool BoardInfo::checkAround(const CellPosition &argPos, StoneColor argColor,
	bool argFlagRev, list<CellPosition> *argList) const
{
	// ̐F𓾂
	StoneColor	oppositeColor = Stone::opposite(argColor);

	// ̐FאڂĂlߍރXg
	list<CellPosition>	vecList;

	// Ӄ`FbN
	CellPosition		aroundPos;
	for(int i = -1; i <= 1; ++i) {
		aroundPos.x = argPos.x + i;
		if(aroundPos.x < 0 || aroundPos.x > BOARD_WIDTH-1) continue;
		for(int j = -1; j <= 1; ++j) {
			if(i == 0 && j == 0) continue;
			aroundPos.y = argPos.y + j;
			if(aroundPos.y < 0 || aroundPos.y > BOARD_WIDTH-1) continue;
			if(cellInfo[aroundPos.x][aroundPos.y].color == oppositeColor) {
				vecList.push_back(CellPosition(i, j));
			}
		}
	}

	// ӂɑ̐΂炻̎_ŏI
	if(vecList.size() == 0) return false;

	// ЂԂ̃Xg(tmp͈ꎞIȋLpAŏIIȃXg͈œnĂ|C^ɕԂ)
	list<CellPosition>	tmpRevList;
	argList->clear();

	// ̐F̐Ɏ̐F邩`FbN
	for(ListIte ite = vecList.begin(); ite != vecList.end(); ++ite) {
		// ׂ_NbNZɃZbg
		CellPosition	vCheck = argPos;
		// Ce[^͊i[vf̃|C^\̂->Ńo
		// ΂uĂȂAʒ[A̐FÂꂩŔ郋[v
		while(true) {
			// Xgɋlߍ܂Ă炷
			vCheck = vCheck + (*ite);
			//vCheck.x += ite->x;
			//vCheck.y += ite->y;
			// Ֆʓ
			if(vCheck.isValid()) {
				if(cellInfo[vCheck.x][vCheck.y].color == argColor) {
					// ̐F̂OK
					// tmpXgɓ˂łЂԂtotalɈړ
					for(ListIte tmpIt = tmpRevList.begin();
						tmpIt != tmpRevList.end(); ++tmpIt)
					{
						// Ce[^*tƎ̂o
						argList->push_back(*tmpIt);
					}
					tmpRevList.clear();	// NAbreak
					break;
				} else if(cellInfo[vCheck.x][vCheck.y].color == oppositeColor) {
					// ܂̐FȂ̂ŒTs
					tmpRevList.push_back(vCheck);	// tmpXgɂЂԂ邩ȂWǉ
				} else {
					// ΂uĂȂ̂NG
					tmpRevList.clear();	// NAbreak
					break;
				}
			} else {
				// ՖʊOɏôNG
				tmpRevList.clear();		// NAbreak
				break;
			}
		}
	}

	return (argList->size() != 0);
}

// [6/19]3Wlz̍Wlɕϊ(萔Ή)
CellPosition BoardInfo::calcID(const fk_Vector &argPos)
{
	CellPosition	pos;
	pos.x = (int)(argPos.x + (BOARD_WIDTH-1)*5)/10;
	pos.y = (int)(argPos.z + (BOARD_WIDTH-1)*5)/10;

	// ͈͊O`FbN
	if(pos.x < 0 || pos.x > BOARD_WIDTH-1 || pos.y < 0 || pos.y > BOARD_WIDTH-1) {
		pos.x = pos.y = -1;
	}

	return pos;
}

fk_Vector BoardInfo::calcPos(const CellPosition &argPos)
{
	fk_Vector	pos;
	pos.x = (double)argPos.x*10 - (BOARD_WIDTH-1)*5;
	pos.y = 0.0;
	pos.z = (double)argPos.y*10 - (BOARD_WIDTH-1)*5;

	return pos;
}
